
function [Dist] = Entropy(X,XX,Vmax)

Xlth=length(XX);
RangeMax=max(X);
SubE=zeros(1,RangeMax);
for i=1:RangeMax
    p=length(find(X==i))/Xlth;
    if p==0
        SubE(i)=0;
    else
        SubE(i)=-p*log2(p);
    end
end
EntropyX=sum(SubE);
SubS=ones(1,Vmax)*(-(1/Vmax)*log2(1/Vmax));
StandEntropy=sum(SubS);
Dist=EntropyX/StandEntropy;
end

