
function [ACC,ARI,NMI] = KMD_Main(X,Modes,Owd)

[Pm.Xlth,Pm.Xwd]=size(X);
XLable=(X(:,Pm.Xwd));
Pm.Xwd=Pm.Xwd-1;
X=X(:,1:Pm.Xwd);
Pm.k=max(XLable);
LctRec=zeros(Pm.Xlth,1);
Pm.Owd=Owd;
[~,~,AttMtx] = UDMPre(X,Pm);
Change=1;
Loop=0;
while Change==1 && Loop<=50
    Change=0;
    Loop=Loop+1;
    for i=1:Pm.Xlth
        DistVec=zeros(Pm.k,1);
        for j=1:Pm.k
            DistVec(j) = UDMDist(X(i,:),Modes(j,:),AttMtx,Pm);
        end
        [~,Winner]=min(DistVec);
        if LctRec(i)~=Winner
            Change=1;
            LctRec(i)=Winner;
        end
    end
    for i=1:Pm.k
        for j=1:Pm.Xwd
            StaList=find(LctRec==i);
            if isempty(StaList)==0
                Sta=tabulate(X(StaList,j));
                [~,LctSta]=max(Sta(:,2));
                Modes(i,j)=Sta(LctSta,1);
            end
        end
    end
end
ACC=Eva_CA(LctRec,XLable);
ARI=Eva_ARI(LctRec, XLable, 'adjusted');
NMI=Eva_NMI(XLable, LctRec);
end
